﻿// For an introduction to the Blank template, see the following documentation:
// http://go.microsoft.com/fwlink/?LinkId=232509
(function () {
    "use strict";

    var app = WinJS.Application;
    var activation = Windows.ApplicationModel.Activation;

    app.onactivated = function (args) {
        if (args.detail.kind === activation.ActivationKind.launch) {
            if (args.detail.previousExecutionState !== activation.ApplicationExecutionState.terminated) {
                // TODO: This application has been newly launched. Initialize
                // your application here.
            } else {
                // TODO: This application has been reactivated from suspension.
                // Restore application state here.
            }
            args.setPromise(WinJS.UI.processAll());

            document.getElementById("showCredentialPicker").addEventListener("click", showCredentialPicker);
            document.getElementById("showCredentialPickerIfNotStored").addEventListener("click", showCredentialPickerIfNotStored);

            asyncVaultLoad();
        }
    };

    function asyncVaultLoad() {
        return new WinJS.Promise(function (complete, error, progress) {
            var vault = new Windows.Security.Credentials.PasswordVault();

            // any call to the password vault will load the vault
            var creds = vault.retrieveAll();
            complete();
        });
    }

    function showCredentialPicker() {
        var options = new Windows.Security.Credentials.UI.CredentialPickerOptions();
        options.message = "Let's login!";
        options.caption = "CredentialPickerSample";
        options.targetName = "Target";
        options.alwaysDisplayDialog = true;
        options.errorCode = 1326; // Shows "The username or password is incorrect."
        options.callerSavesCredential = true;
        options.authenticationProtocol = Windows.Security.Credentials.UI.AuthenticationProtocol.negotiate;
        options.credentialSaveOption = Windows.Security.Credentials.UI.CredentialSaveOption.selected;
 
        Windows.Security.Credentials.UI.CredentialPicker.pickAsync(options).done(function (results) {
            
        });
    }

    var resourceName = "My App";

    function showCredentialPickerIfNotStored() {
        var loginCredential = getCredentialFromLocker();

        if (loginCredential != null) {
            loginCredential.retrievePassword();
            document.getElementById("output").innerText = loginCredential.userName + ": " + loginCredential.password;
        } else {
            Windows.Security.Credentials.UI.CredentialPicker.pickAsync("target", "please enter credentials").done(function (results) {
                loginCredential = results;
                storeCredentialsInLocker(loginCredential);

                document.getElementById("output").innerText = loginCredential.credentialUserName + ": " + loginCredential.credentialPassword;
            });
        }
    }
    function storeCredentialsInLocker(loginCredential) {
        var vault = new Windows.Security.Credentials.PasswordVault();
        var cred = new Windows.Security.Credentials.PasswordCredential(resourceName,
                                                               loginCredential.credentialUserName,
                                                               loginCredential.credentialPassword);
        vault.add(cred);
    }

    function getCredentialFromLocker() {

        try {
            var vault = new Windows.Security.Credentials.PasswordVault();
            var credentialList = vault.findAllByResource(resourceName);
            if (credentialList.length > 0) {
                return credentialList[0];
            }
            else {
                return null;
            }
        }
        catch (ex) {
            return null;
        }
    }


    app.oncheckpoint = function (args) {
        // TODO: This application is about to be suspended. Save any state
        // that needs to persist across suspensions here. You might use the
        // WinJS.Application.sessionState object, which is automatically
        // saved and restored across suspension. If you need to complete an
        // asynchronous operation before your application is suspended, call
        // args.setPromise().
    };

    app.start();
})();
